<?php

class ObjectGenerator extends CI_Controller {
    
    public function Generate() {
        $this->GenerateObject();
        $this->GenerateForm();
    }
    
    public function GenerateObject() {
        $classArray = array();
        $this->db_pito = $this->load->database('pito', TRUE);
        
        $this->db_pito->select('objectName');
        $this->db_pito->from('objects');

        $query = $this->db_pito->get();
        $data = $query->result();
        
        foreach ($data as $obj) {
            array_push($classArray, $obj->objectName);
        }
        
        $folderName = "pito_class";
        foreach ($classArray as $classToBeGenerated) {
            $table = $classToBeGenerated;
            $className = ucfirst($table);
            $className .= 'Object';
            $fileName = $className . '.php';

            $realpath = realpath(APPPATH);

            $folderPath = $realpath . '/' . $folderName;
            echo 'Folder Path: ';
            var_dump($folderPath);
            echo 'class to generate: ';
            var_dump($table);
            echo 'class name: ';
            var_dump($className);
            echo 'file name: ';
            var_dump($fileName);

            if (empty($table)) {
                throw new Exception('Class to work with not specified');
            }
            if (empty($fileName)) {
                throw new Exception('file to create with not specified');
            }

            $variables = $this->GetObjectFields($table, 'object');
            $variablesArray = array();
            foreach ($variables as $value) {
                //var_dump($value->name);
                array_push($variablesArray, $value->name);
            }
            
//            var_dump($variablesArray);
//            continue;

            $this->CheckPropertiesForRelations($variablesArray);
            //spaces
            $sp = "\040\040\040\040";
            //double spaces
            $dsp = $sp . $sp;
            //$stringToWrite = array();
            $stringToWrite = "<?php \nrequire_once('application/pito_class/PitoMain.php');\n" . 
                    "require_once('application/pito_class/PitoValidation.php');" . "\n" .
                    "\n/**\n";


            //Writing phpdoc for properties
            foreach ($variablesArray as $value) {
                $stringToWrite .= "* @property type $$value" . "\n";
            }
            $stringToWrite .= "*/\n";
            $stringToWrite .= "class $className extends PitoMain {\n\n$sp" . 
                    "private \$_parent;\n$sp" .
                    "protected \$_type;\n\n" ;
            //Printing variables
            foreach ($variablesArray as $value) {
                $stringToWrite .= $sp . "protected $$value;\n";
            }
            $stringToWrite .= "\n";
//            $stringToWrite .= $sp . '//$_propertyNames съхранява като ключ името на property-то, '
//                    . 'записано в базата и като стойност името на член данната на обекта' . "\n" .
//                    $sp . "//Ако property не съвпада с името на обекта се описва в този масив и се подава "
//                    . "на AssignFields като трети параметър\n" .
//                    $sp . 'private $_propertyNames = array();' . "\n\n";
            //Обектът има вътрешно property formObject и масив с грешки при валидация
            $stringToWrite .= $sp . 'protected $' . $table . 'Form;' . "\n" .
                    $sp . 'protected $errorArray;' . "\n\n";

            $stringToWrite .= $this->Constructor($table, 'object');
            $stringToWrite .= $this->MagicMethods($table, 'object');
            $stringToWrite .= $this->LoadElement($table);
            $stringToWrite .= $this->CreateUpdateDelete($table);
            $stringToWrite .= $this->Search($table);
            $stringToWrite .= $this->GetAll($table);
            $stringToWrite .= $this->GetAllPropertyNames($variablesArray);
            $stringToWrite .= $this->GetArrayForDatabase($table, $variablesArray);
            $stringToWrite .= $this->GetJsonData();
            $stringToWrite .= $this->GetErrorArray();
            $stringToWrite .= $this->Validate($table);
            $stringToWrite .= $this->GetId($variablesArray);
            $stringToWrite .= $this->AssignValuesFromObject();

            $stringToWrite .= "\n}";
            $fullpath = $folderPath . '/objects/' . $fileName;
            file_put_contents($fullpath, $stringToWrite);
        }
    }
    
    public function GenerateForm() {
        $classArray = array();
        $this->db_pito = $this->load->database('pito', TRUE);

        $this->db_pito->select('objectName');
        $this->db_pito->from('objects');

        $query = $this->db_pito->get();
        $data = $query->result();

        foreach ($data as $obj) {
            array_push($classArray, $obj->objectName);
        }

        $folderName = "pito_class";
        foreach ($classArray as $classToBeGenerated) {
            $table = $classToBeGenerated;
            $className = ucfirst($table);
            $className .= 'Form';
            $fileName = $className . '.php';

            $realpath = realpath(APPPATH);

            $folderPath = $realpath . '/' . $folderName;
            echo 'Folder Path: ';
            var_dump($folderPath);
            echo 'class to generate: ';
            var_dump($table);
            echo 'class name: ';
            var_dump($className);
            echo 'file name: ';
            var_dump($fileName);

            if (empty($table)) {
                throw new Exception('Class to work with not specified');
            }
            if (empty($fileName)) {
                throw new Exception('file to create with not specified');
            }
            $realpath = realpath(APPPATH);
            //$variablesArray = $this->GetObjectFields($table);
            
            $variables = $this->GetObjectFields($table, 'form');
            $variablesArray = array();
            
            foreach ($variables as $value) {
                //var_dump($value->name);
                array_push($variablesArray, $value->name);
            }

            $this->CheckPropertiesForRelations($variablesArray);
            //spaces
            $sp = "\040\040\040\040";
            //double spaces
            $dSp = $sp . $sp;
            $stringToWrite = array();
            $stringToWrite = "<?php \nrequire_once('application/pito_class/PitoFormMain.php');\n\n/**\n";


            //Writing phpdoc for properties
            foreach ($variablesArray as $value) {
                $stringToWrite .= "* @property type $$value" . "\n";
            }
            $stringToWrite .= "*/\n";
            $stringToWrite .= "class $className extends PitoFormMain {\n\n$sp" . "private \$_parent;\n\n";
            //Printing variables
            foreach ($variablesArray as $value) {
                $stringToWrite .= $sp . "public $$value;\n";
            }
            $stringToWrite .= "\n";

            $stringToWrite .= $this->Constructor($table, 'form');
            $stringToWrite .= $this->MagicMethods($table, 'form');
            $stringToWrite .= $this->GetAllPropertyNames($variablesArray);

            $stringToWrite .= "\n}";
            $fullpath = $folderPath . '/forms/' . $fileName;
            file_put_contents($fullpath, $stringToWrite);
        }
    }

    private function GetObjectFields($table, $classType) {
        $this->db_pito = $this->load->database('pito', TRUE); 
        
        $this->db_pito->select('fields.name,');
        $this->db_pito->from('fields');
        $this->db_pito->join('objects', 'fields.objectId = objects.objectId');
        $this->db_pito->order_by('id asc');
        $this->db_pito->where('objects.objectName', $table);
        $this->db_pito->where('(`fields`.`classtype` = \'' . $classType . '\' OR `fields`.`classtype` = \'both\')');
        
        //$where = "objects.objectName = $table AND ()";
        
        
        $query = $this->db_pito->get();
        $data = $query->result();
        //var_dump($this->db_pito->last_query());
        
        return $data;
        
        //$fields = $this->db->list_fields($table);
        
        //return $fields;
    }
    
    private function GetObjectFieldsById($id) {
        $this->db_pito = $this->load->database('pito', TRUE); 
        
        $this->db_pito->select('fields.name, fields.related,');
        $this->db_pito->from('fields');
        $this->db_pito->order_by('id asc');
        $this->db_pito->join('objects', 'fields.objectId = objects.objectId');
        $this->db_pito->where('objects.objectId', $id);
        
        $query = $this->db_pito->get();
        $data = $query->result();
        
        return $data;
    }
    
    private function CheckPropertiesForRelations($variablesArray) {
        foreach ($variablesArray as $value) {
            //var_dump($value->related);
            if (!empty($value->related)) {
                $value->relatedObject = $this->GetObjectFieldsById($value->related);
                $this->CheckPropertiesForRelations($value->relatedObject);
            }
        }
    }
    
    private function MagicMethods($table, $type) {
        //spaces
        $sp = "\040\040\040\040";
        //double spaces
        $dSp = $sp . $sp;
        $stringToWrite = '';
        //Writing magic methods
        //Writing __get method
        $stringToWrite .= $sp . 'public function __get($name) {' . "\n" .
                $dSp . 'if (isset($this->$name)) {' . "\n" .
                $dSp . $sp . 'return $this->$name;' . "\n" .
                $dSp . "} \n$dSp" . "else {" . "\n" .
                $dSp . $sp . 'if (isset(parent::$name)) {' . "\n" .
                $dSp . $dSp . 'return parent::__get($name);' . "\n" .
                $dSp . $sp . "}\n" . 
                $dSp . $sp . "else {\n" .
                $dSp . $dSp . 'return null;' . "\n" .
                $dSp . $sp . "}\n" .
                $dSp . "}\n" . $sp . "}\n\n";

        //Writing __set method
        $stringToWrite .= $sp . 'public function __set($name, $value) {' . "\n" .
                $dSp . 'if (property_exists($this, $name)) {' . "\n";
        
        if ($type == 'object') {
            $stringToWrite .= $dSp . $sp . '$requirements = $this->' . $table . 'Form->$name;' . "\n" .
                    $dSp . $sp . '$this->errorArray[$name] = PitoValidation::Validate($value, $requirements[\'requirements\']);' . "\n\n" .
                    $dSp . $sp . 'if (empty($this->errorArray[$name]) || $this->errorArray[$name] === true) {' . "\n" .
                    $dSp . $dSp . 'if (!empty($this->errorArray) && key_exists($name, $this->errorArray)) {' . "\n" .
                    $dSp . $dSp . $sp . 'unset($this->errorArray[$name]);' . "\n" .
                    $dSp . $dSp . "}\n\n" .
                    $dSp . $dSp . '$this->$name = $value;' . "\n" .
                    $dSp . $sp . "}\n";
        } 
        else {
            $stringToWrite .= $dSp . $sp . '$this->$name = $value;' . "\n";
        }

        $stringToWrite .= $dSp . "} \n" . $dSp . "else { \n" .
                $dSp . $sp . 'if (property_exists($this->_parent, $name)) {' . "\n" .
                $dSp . $dSp . 'parent::__set($name, $value);' . "\n" . $dSp . $sp . "}\n" .
                $dSp . $sp . "else {\n" .
                $dSp . $dSp . 'throw new Exception(\'Unknown property \' . $name);' . "\n" .
                $dSp . $sp . "}\n" . $dSp . "}\n" . $sp . "}\n\n";

        //Writing __isset() method
        $stringToWrite .= $sp . 'public function __isset($name) {' . "\n" .
                $dSp . 'return isset($this->$name);' . "\n" .
                $sp . "}\n\n";
        
        return $stringToWrite;
    }
    
    private function LoadElement($table) {
        //spaces
        $sp = "\040\040\040\040";
        //double spaces
        $dsp = $sp . $sp;        
        $stringToWrite = '';
        //Writing LoadElement method
        $stringToWrite .= $sp . "/**\n$sp * Loads the values in the object\n" .
                $sp . ' * @param type  $ID              the ID of the object to load' . "\n" . 
                $sp . ' * @param integer $nestingLevel  the number of nested objects' . "\n" .
                $sp . ' * @throws Exception if an element with the passed ID is not found' . "\n$sp */\n";
        $stringToWrite .= $sp . 'public function LoadElement($ID, $nestingLevel=0) {' . "\n" .
                $dsp . '$object = parent::GetObjectById(\'' . $table . '\', $ID);' . "\n" .
                $dsp . '$fields = parent::GetFormAndRequirements(\''. $table . '\');' . "\n\n" .
                $dsp . '//Взима имената на всичките property-та' . "\n" .
                $dsp . '$classProperties = get_object_vars($this);' . "\n" .
                $dsp . 'if (empty($object)) {' . "\n" .
                $dsp . $sp . '$className = get_class($this);' . "\n" .
                $dsp . $sp . 'return;' .
                "\n$dsp}\n\n" . $dsp .'foreach ($object as $key => $value) {' . "\n" . 
                $dsp . $sp . 'if (property_exists($this, $key)) {' . "\n" . 
                $dsp . $dsp . '$this->$key = $value;' . "\n$dsp$sp}\n" . 
                $dsp . $sp . "else {\n" . 
                $dsp . $dsp . '$propName = substr($key, 0, -2);' . "\n" .
                $dsp . $dsp . 'if (property_exists($this, $propName)){'
                . ' if($nestingLevel > 0) {' . "\n" .
                $dsp . $dsp . '$passedNestingLevel = $nestingLevel;' . "\n" .
                $dsp . $dsp . '$passedNestingLevel--;' . "\n\n" .
                $dsp . $dsp . '$className = parent::GetPropertyClass($propName, \'' . $table . '\');' . "\n\n" .

                $dsp .$dsp . '$this->$propName = new $className();' . "\n" .
                $dsp . $dsp . $sp . '$this->$propName->LoadElement($value, $passedNestingLevel);' . "\n" . 
                $dsp . $dsp . '}else{$this->$propName = $value;}}' . $dsp . $sp . "}\n" . $dsp . "}\n\n" . 
                $dsp . "//Ако някоя член-данна има суфикс List тогава се търси за релация в базата.\n" . 
                $dsp . "//Link показва, че съществува релация с друга таблица докато името на променливата\n" . 
                $dsp . "//указва с коя таблица има връзка. \n" . 
                $dsp . 'foreach ($classProperties as $key => $value) {' . "\n" . 
                $dsp . $sp . "//Името на променливата без последните четири символа (без List)\n" .
                $dsp . $sp . '$listPropName = substr($key, 0, -4);' . "\n" . 
                $dsp . $sp . "//Последните четири символа (List)\n" . 
                $dsp . $sp . '$propEndName = substr($key, strlen($listPropName));' . "\n" . 
                $dsp . $sp . '//Проверява се дали името на променливата завършва на "List" - ако е се търси релация' . "\n" . 
                $dsp . $sp . 'if ($propEndName == \'List\') {' . "\n" .
                $dsp . $dsp . 'if (property_exists($this, $key) && $nestingLevel > 0) {' . "\n" .
                $dsp . $dsp . '$passedNestingLevel = $nestingLevel;' . "\n" .
                $dsp . $dsp . '$passedNestingLevel--;' . "\n" .
                $dsp . $dsp . $sp . '$this->$key = parent::FindRelatedRecords($listPropName, \'' . 
                $table .'\', $this->' . $table . 'ID, $passedNestingLevel);' . "\n" . $dsp . $dsp . "}\n" .
                $dsp . $sp . "}\n" . $dsp . "}\n" . $sp . "}\n\n";
        
        return $stringToWrite;
    }
    
    private function CreateUpdateDelete($table) {
        //spaces
        $sp = "\040\040\040\040";
        //double spaces
        $dsp = $sp . $sp;
        
        $stringToWrite = '';
        //Writing Save() method
        $stringToWrite .= "$sp/**\n$sp * Saves or updates the object's values to the database\n$sp */\n" . 
                $sp . 'public function Save() {' . "\n" .
                $dsp . '$arrayToInsert = $this->GetArrayForDatabase();' . "\n" .
                $dsp . '$objectID = $this->GetID();' . "\n\n" .
                $dsp . '$ci =& get_instance();' . "\n" . 
                $dsp . '$ci->load->model(\'PitoModel\');' . "\n" .
                $dsp . '$' . $table . 'ID = $ci->PitoModel->SaveObject($arrayToInsert, \'' . $table . '\', $objectID);' . "\n\n" .
                $dsp . 'if($' . $table . 'ID !== true){' . "\n" .
                $dsp . $sp . '$this->' . $table . 'ID = $' . $table . 'ID;' . "\n" .
                $dsp . "}\n" .
                $sp . "}\n\n";
        
        //Writing Create() method
        $stringToWrite .= "$sp/**\n$sp * Save the object's values to the database\n" .
                $sp . " * * @deprecated since version 2.0\n" .
                "$sp */\n" . 
                $sp . 'public function Create() {' . "\n" .
                $dsp . '$ci =& get_instance();' . "\n" . 
                $dsp . '$ci->load->model(\'' . ucfirst($table) . 'Model\');' . "\n" .
                $dsp . '$this->' . $table . 'ID = $ci->' . ucfirst($table) .'Model->Save' . '($this);' . "\n" .
                $sp . "}\n\n";
        
        //Writing the update method
        $stringToWrite .= "$sp/**\n$sp * Saves the changes to the database\n" .
                $sp . " * * @deprecated since version 2.0\n" .
                "$sp */\n" . 
                $sp . 'public function Update() {' . "\n" .
                $dsp . '$ci =& get_instance();' . "\n" .
                $dsp . '$ci->load->model(\'' . ucfirst($table) . 'Model\');' . "\n" .
                $dsp . '$ci->' . ucfirst($table) .'Model->Save($this);' . "\n" .
                $sp . "}\n\n";
        
        //Writing the delete method
        $stringToWrite .= "$sp/**\n$sp * Sets the object as deleted\n$sp */\n" . 
                $sp . 'public function Delete() {' . "\n" .
                $dsp . '$ci =& get_instance();' . "\n" .
                $dsp . '$ci->load->model(\'' . ucfirst($table) . 'Model\');' . "\n" .
                $dsp . '$ci->' . ucfirst($table) .'Model->Delete($this' . ");\n" .
                $sp . "}\n\n"; 
        
        return $stringToWrite;
    }
    
    private function Search($table) {
        //spaces
        $sp = "\040\040\040\040";
        //double spaces
        $dSp = $sp . $sp;
        $stringToWrite = '';
        //Writing the search method
        $stringToWrite .= $sp . "/**\n" .
                $sp . " * Searches in the database on for an array where the key is the colum and the value is the search criteria\n" .
                $sp . ' * @param type  $searchArray  the array that holds the search criteria as key => value' . "\n" .
                $sp . ' * @param integer $nestingLevel the nested objects count' . "\n" .
                $sp . ' * @return array' . "\n$sp */\n" .
                $sp . 'public static function Search($searchArray, $nestingLevel=0,$sortArray=array(),$page = "",$limit="") {' . "\n" .
                $dSp . '$resultArray = parent::Search(\'' . $table . '\', $searchArray, $nestingLevel--,$sortArray,$page = "",$limit="");' . "\n" .
                $dSp . 'return $resultArray;' . "\n$sp}\n\n";
        
        return $stringToWrite;
    }
    
    private function GetAll($table) {
        //spaces
        $sp = "\040\040\040\040";
        //double spaces
        $dsp = $sp . $sp;
        $stringToWrite = '';
        //Writing the search method
        $stringToWrite .= $sp . "/**\n" .
                $sp . " * Gets all of the elements in the database\n" .
                $sp . ' * @param integer $nestingLevel the nested objects count' . "\n" .
                $sp . ' * @return array' . "\n$sp */\n" .
                $sp . 'public function GetAll($nestingLevel=0) {' . "\n" .
                $dsp . '$searchArray = array(' . "\n" .
                $dsp . $sp . "array(\n" .
                $dsp . $dsp . "'column' => '$table" . "ID',\n" .
                $dsp . $dsp . "'value' => 0,\n" .
                $dsp . $dsp . "'operator' => '>=',\n" .
                $dsp . $sp . ")\n" . $dsp . ");\n\n" .
                $dsp . '$passedNestingLevel = $nestingLevel;' . "\n" .
                $dsp . '$passedNestingLevel--;' . "\n" .
                $dsp . '$resultArray = parent::Search(\'' . $table . '\', $searchArray, $passedNestingLevel);' . "\n" .
                $dsp . 'return $resultArray;' . "\n$sp}\n\n";
        
        return $stringToWrite;
    }
    
    private function Constructor($table, $objectType = '') {
        //spaces
        $sp = "\040\040\040\040";
        //double spaces
        $dSp = $sp . $sp;
        $stringToWrite = '';
        //Writing contructor
        $stringToWrite .= "\n";
        $stringToWrite .= $sp . 'public function __construct($nestingLevel=0, $elementID=\'\') {' ."\n" .
                $dSp . '$this->_parent = get_parent_class($this);' . "\n\n";
        
        if ($objectType == 'object') {
            $stringToWrite .= $dSp . "//Gets only the fields with the relations 1:1. Returns an array of objects\n" .
                    $dSp . '$fields = parent::GetFormAndRequirements(\'' . $table . '\');' . "\n";
            $stringToWrite .= $dSp . '$this->AssignFields($fields, $nestingLevel);' . "\n" .
                    $dSp . '$this->' . $table . 'Form = new ' . ucfirst($table) . 'Form();' . "\n" .
                    $dSp  . '$this->errorArray = array();' . "\n\n"
            ;


            $stringToWrite .= $dSp . '$this->_type = str_replace(\'Object\', \'\', get_class());' . "\n\n";
            
            $stringToWrite .= $dSp . 'if (!empty($elementID)) {' . "\n" .
                    $dSp . $sp . '$this->LoadElement($elementID, $nestingLevel);' . "\n" .
                    $dSp . "}\n"
                ;
            $stringToWrite .= "$sp}\n\n";
        }
        else {
            $stringToWrite .= $dSp . "//Gets the data for the form object and the relations 1:1. Returns an array of objects\n" .
                $dSp . '$fields = parent::GetFormAndRequirements(\'' . $table . '\');' . "\n";
            $stringToWrite .= $dSp . '$this->AssignFields($fields, $nestingLevel);' . "\n$sp}\n\n";
        }
        


        return $stringToWrite;
    }
    
    private function GetAllPropertyNames($variablesArray) {
        //spaces
        $sp = "\040\040\040\040";
        //double spaces
        $dsp = $sp . $sp;
        $stringToWrite = '';
        
        //Writing GetAllPropertyNames()
        $stringToWrite .= $sp . "/**\n" .
                $sp . " * Returns an array with all the object's property names\n" . 
                $sp . " * @return Array\n" . 
                $sp . " */\n" . 
                $sp . "public function GetAllPropertyNames() {\n" . 
                $dsp . "return array(";
        foreach ($variablesArray as $value) {
            $stringToWrite .= "'$value', ";
        }
        
        $stringToWrite .= ");\n" . $sp . "}\n\n";

        return $stringToWrite;
    }
    
    private function GetArrayForDatabase($table, $variablesArray) {
        //spaces
        $sp = "\040\040\040\040";
        //double spaces
        $dsp = $sp . $sp;
        $stringToWrite = '';
        
        $dbFields = $this->db->list_fields($table);
        
        $stringToWrite .= $sp . 'private function GetArrayForDatabase() {' . "\n" . 
                $sp . '//Ако данните в обекта не са валидни ще се хвърли Exception вместо да се подаде неверен масив' . "\n" . 
                $sp . '$this->Validate();' . "\n" .
                $sp . '$errorArray = $this->GetErrorArray();' . "\n\n" . 
                $sp . 'if (!empty($errorArray)) {' . "\n" . 
                $dsp . 'throw new Exception("Cannot save object: invalid value for one or more properties.");' . "\n" . 
                $sp . "}\n\n" .
                $sp . '$mappedFields = array(' . "\n";
                
        var_dump($dbFields);
        var_dump($variablesArray);
                for($index = 0; $index < count($dbFields); $index++) {
                    $stringToWrite .= $dsp . "'$dbFields[$index]' => '$variablesArray[$index]',\n";
                }
        
                $stringToWrite .= $sp . ");\n\n" .
                $sp . '$objectValues = get_object_vars($this);' . "\n\n" .
                $sp . 'foreach ($objectValues as $key => &$value) {' . "\n" . 
                $dsp . '//Ако член данна няма да се записва в базата се маха' . "\n" . 
                $dsp . 'if (!in_array($key, $mappedFields)) {' . "\n" . 
                $dsp . $sp . 'unset($objectValues[$key]);' . "\n" . $dsp . "}\n" . 
                $dsp . '//Проверява се дали property-то не е обект, ако е се взима само ID-то му' . "\n" . 
                $dsp . 'if (is_object($value)) {' . "\n" . 
                $dsp . $sp . 'if (method_exists($value, \'GetID\')) {' . "\n" . 
                $dsp . $dsp . '$value = $value->GetID();' . "\n" .
                $dsp . $sp . "}\n" .
                $dsp . $sp . 'else {' . "\n" .
                $dsp . $dsp . '//Частен случай, ако е обект, но няма GetID() метод' . "\n" . 
                $dsp . $dsp . '$value = null;' . "\n" . 
                $dsp . $sp . "}\n" . $dsp . "}\n" . $sp . "}\n\n" .
                $dsp . '$arrayToReturn = array();' . "\n\n" .
                $dsp . 'foreach ($mappedFields as $key => $value) {' . "\n" . 
                $dsp . $sp . '$arrayToReturn[$key] = $objectValues[$value];' . "\n" . 
                $dsp . "}\n\n" .
                $dsp . 'return $arrayToReturn;' . "\n" . 
                $sp . "}\n\n"
                ;
        
        return $stringToWrite;
    }
    
    private function GetJsonData() {
        //spaces
        $sp = "\040\040\040\040";
        //double spaces
        $dsp = $sp . $sp;
        $stringToWrite = '';
        
        $stringToWrite .= $sp . "/**\n" . 
                $sp . " * Returns the object's properties as a JSON object\n" .
                $sp . ' * @param integer $nestingLevel the nesting level of the object\'s properties that are object themselves' . "\n" .
                $sp . ' * * @param array $objectNameArray the array that holds the previously called objects' . "\n" .
                $sp . " * @return array\n" .
                $sp . " */\n"
                ;
        $stringToWrite .= $sp . 'public function GetJsonData($nestingLevel=0, $objectNameArray = array()){' . "\n" .
                $dsp . '$className = get_class($this);' . "\n\n" . 
                $dsp . '//Ако името на класа на обекта е в масива, тогава информацията вече е извлечена на по-ранен' . "\n" . 
                $dsp . '//етап, а в този case се е получило рекурсивно извикване на GetJsonData за този обект' . "\n" .
                $dsp . 'if (in_array($className, $objectNameArray)) {' . "\n" . 
                $dsp . $sp . 'return null;' . "\n" .
                $dsp . "}\n" .
                $dsp . '$objectNameArray[$className] = $className;' . "\n\n" . 
                $dsp . '$objectValues = get_object_vars($this);' . "\n" . 
                $dsp . '$propertyNames = $this->GetAllPropertyNames();' . "\n\n" .
                $dsp . 'foreach ($objectValues as $key => &$value) {' . "\n" .
                $dsp . $sp . "//Ако член данна не трябва да се предоставя на потребителя се маха от масива със стойностите на обекта\n" . 
                $dsp . $sp . 'if (!in_array($key, $propertyNames) && $key != \'_type\') {' . "\n" . 
                $dsp . $dsp . 'unset($objectValues[$key]);' . "\n" . 
                $dsp . $sp . "}\n\n" . 
                $dsp . $sp . 'if (is_object($value) && method_exists($value, \'GetJsonData\') && $nestingLevel > 0) {' . "\n" . 
                $dsp . $dsp . '$value = $value->GetJsonData($nestingLevel - 1, $objectNameArray);' . "\n" .
                $dsp . $sp . "}\n" .
                $dsp . $sp . "else {\n" .
                $dsp . $dsp . 'if (is_object($value) && $nestingLevel <= 0) {' . "\n" .
                $dsp . $dsp . $sp . 'if (method_exists($value, \'GetID\')) {' . "\n" .
                $dsp . $dsp . $dsp . '$value = $value->GetID();' . "\n" .
                $dsp . $dsp . $sp . "}\n" .
                $dsp . $dsp . $sp . "else {\n" . 
                $dsp . $dsp . $dsp . '$value = null;' . "\n" .
                $dsp . $dsp . $sp . "}\n" .
                $dsp . $dsp . "}\n" .
                $dsp . $sp . "}\n" . 
                $dsp . "}\n\n" .
                $dsp . 'return $objectValues;' . "\n" . 
                $sp . "}\n\n"
            ;
        
        return $stringToWrite;
    }
    
    private function GetErrorArray() {
        //spaces
        $sp = "\040\040\040\040";
        //double spaces
        $dsp = $sp . $sp;
        $stringToWrite = '';
        $stringToWrite .= $sp . "/**\n" .
                $sp . " * Returns the error array from the validation. Each key is a name of a property in which there were validation errors\n" .
                $sp . " * and holds an array in which each element is an error\n" .
                $sp . " * @return array\n" . 
                $sp . " */\n";
        
        $stringToWrite .= $sp . "public function GetErrorArray() {\n" .
                $dsp . 'return $this->errorArray;' . "\n" .
                $sp . "}\n\n";
        
        return $stringToWrite;
    }
    
    private function Validate($table) {
        //spaces
        $sp = "\040\040\040\040";
        //double spaces
        $dsp = $sp . $sp;
        $stringToWrite = '';
        $stringToWrite .= $sp . "/**\n" .
                $sp . " * Runs through the object and checks if the values pass the validation rules\n" .
                $sp . " * @return boolean\n" . 
                $sp . " */\n";
        
        $stringToWrite .= $sp . "public function Validate() {\n" .
                $dsp . '$properties = $this->GetAllPropertyNames();' . "\n\n" .
                $dsp . 'foreach ($properties as $property) {' . "\n" .
                $dsp . $sp . '$requirements = $this->' . $table . 'Form->$property;' . "\n" .
                $dsp . $sp . '$this->errorArray[$property] = PitoValidation::Validate($this->$property, $requirements[\'requirements\']);' . "\n\n" .
                $dsp . $sp . 'if (empty($this->errorArray[$property]) || $this->errorArray[$property] === true) {' . "\n" . 
                $dsp . $dsp . 'unset($this->errorArray[$property]);' . "\n" .
                $dsp . $sp . "}\n" . 
                $dsp . "}\n\n" . 
                $dsp . 'if (empty($this->errorArray)) {' . "\n" . 
                $dsp . $sp . "return true;\n" . $dsp . "}\n" . 
                $dsp . "else {\n" . 
                $dsp . $sp . "return false;\n" .
                $dsp . "}\n" . $sp . "}\n\n"
                ;
        
        return $stringToWrite;
        
    }
    
    private function GetId($variablesArray) {
        //spaces
        $sp = "\040\040\040\040";
        //double spaces
        $dsp = $sp . $sp;
        $stringToWrite = '';
        
        $stringToWrite .= $sp . "/**\n" .
                $sp . " * Gets the object' ID or returns null\n" .
                $sp . " * @return int\n" . 
                $sp . " */\n";
        
        $stringToWrite .= $sp . 'public function GetID() {' . "\n" .
                $dsp . 'if (!empty($this->' . reset($variablesArray) . ')) {' . "\n" . 
                $dsp . $sp . 'return $this->' . reset($variablesArray) . ';' . "\n" .
                $dsp . "}\n" . 
                $dsp . "else {\n" .
                $dsp . $sp . "return null;\n" . 
                $dsp . "}\n" . 
                $sp . "}\n\n"
                ;
        
        return $stringToWrite;
    }
    
    private function AssignValuesFromObject() {
        //spaces
        $sp = "\040\040\040\040";
        //double spaces
        $dsp = $sp . $sp;
        $stringToWrite = '';
        
        $stringToWrite .= $sp . "/**\n" .
                $sp . " * Sets the properties of the object by the values from a passed object or array\n" . 
                $sp . " * It will only set a propery if the passed object/array has a property/value with the same name\n" .
                $sp . '* @param mixed $object' . "\n" .
                $sp . " */\n"
                ;
        
        $stringToWrite .= $sp . 'public function AssignValuesFromObject($object) {' . "\n" . 
                $dsp . '$propertyNames = $this->GetAllPropertyNames();' . "\n\n" .
                $dsp . 'if (is_object($object)) {' . "\n" . 
                $dsp . $sp . 'foreach ($propertyNames as $property) {' . "\n" . 
                $dsp . $dsp . 'if (property_exists($this, $property) && property_exists($object, $property)) {' . "\n" . 
                $dsp . $dsp . $sp . '//Проверка дали $object->property-то не е вложен обект от някакъв тип' . "\n" .
                $dsp . $dsp . $sp . 'if (is_object($object->$property) && property_exists($object->$property, \'_type\')) {' . "\n" .
                $dsp . $dsp . $dsp . '$className = $object->$property->_type . "Custom";' . "\n" .
                $dsp . $dsp . $dsp . '//Ако няма Custom клас, да се използва автоматично генерираният' . "\n" .
                $dsp . $dsp . $dsp . '//if (!class_exists($className)) {' . "\n" .
                $dsp . $dsp . $dsp . $sp . '$className = $object->$property->_type . "Object";' . "\n" .
                $dsp . $dsp . $dsp . "//}\n\n" . 
                $dsp . $dsp . $dsp . '//Ако това property е обект, но не е инстанциран се създава' . "\n" .
                $dsp . $dsp . $dsp . 'if (!is_object($this->$property) && class_exists($className)) {' . "\n" .
                $dsp . $dsp . $dsp . $sp . '$this->$property = new $className();' . "\n" .
                $dsp . $dsp . $dsp . $sp . '$this->$property->AssignValuesFromObject($object->$property);' . "\n" .
                $dsp . $dsp . $dsp . "}\n" . 
                $dsp . $dsp . $sp . "}\n" .
                $dsp . $dsp . $sp . 'else {' . "\n" .
                $dsp . $dsp . $dsp . '$this->$property = $object->$property;' . "\n" .
                $dsp . $dsp . $sp . "}\n" .
                $dsp . $dsp . "}\n" .
                $dsp . $sp . "}\n" .
                $dsp . "}\n\n" . 
                $dsp . 'if (is_array($object)) {' . "\n" . 
                $dsp . $sp . 'foreach ($propertyNames as $property) {' . "\n" . 
                $dsp . $dsp . 'if (property_exists($this, $property) && key_exists($property, $object)) {' . "\n" . 
                $dsp . $dsp . $sp . '$this->$property = $object[$property];' . "\n" . 
                $dsp . $dsp . "}\n" . 
                $dsp . $sp . "}\n" . 
                $dsp . "}\n" . 
                $sp . "}"
                ;
        
        return $stringToWrite;        
    }

}