<?php
require_once 'application/pito_class/ValidationErrorMessages.php';

class PitoValidation {
    /**
     * 
     * @param type $value The value to be validated
     * @param String $validationSting The strig that holds the validation rules
     */
    static function Validate($property, $validationSting,$ID=null) {
        //Ако няма условия за валидиране се връща true
        if (empty($validationSting)) {
            return true;
        }
        
        $requirementsArray = explode('|', $validationSting);
        $errorArray = array();
        
        foreach ($requirementsArray as $value) {
            $validationInfo = explode('[', $value);
            if (isset($validationInfo[1])) {
                $validationInfo[1] = substr_replace($validationInfo[1], "", -1);
                
                $methodName =  $validationInfo[0];
                $validationRule = $validationInfo[1];
                if($methodName == "unique")
                $validationResult = self::$methodName($property, $validationRule,$ID);
            //    var_dump($methodName);
            //    var_dump($validationResult);
                
            }
            else {
                $methodName =  $validationInfo[0];
                
                $validationResult = self::$methodName($property);
            }
          //  var_dump($validationResult);
            //var_dump($property);
            //var_dump($validationSting);
           
            //Ако валидацията не е успешна се записва в масив
            if ($validationResult === false) {
                //Ако има допълнителен параметър тогава $validationRule няма да е празно
                //Името на validation rule-a ще бъде във $value
                if (isset($validationRule)) {
                    array_push($errorArray, $value);
                }
                else {
                    //Ако няма допълнителен параметър името на метода ще бъде и името, което ще се преведе
                    array_push($errorArray, $methodName);
                }
                
            }
           // var_dump($errorArray);
        }
        //Взима се езика на CodeIgniter и се подава като параметър на класа, който превежда съощенията за грешка
        $ci =& get_instance();
     //   var_dump($errorArray);
       //  die;
        $language = $ci->config->config['language'];
        $returnArray = ValidationErrorMessages::Translate($errorArray, $language);

        return $returnArray;
    }
    
    private static function required($property) {
        if (!is_array($property)) {
            if (trim($property) !== '') {
                return true;
            }
            else {
                return false;
            }
        }
        else {
            return empty($property);
        }
    }
    
    private static function min_length($property, $lenght) {
        if (preg_match("/[^0-9]/", $lenght)) {
            return false;
        }

        return (strlen($property) < $lenght) ? false : true;
    }

    private static function max_length($property, $lenght) {
        if (preg_match("/[^0-9]/", $lenght)) {
            return false;
        }

        return (strlen($property) > $lenght) ? false : true;
    }
    
    private static function exact_length($property, $lenght) {
        if (!preg_match("/[^0-9]/", $lenght)) {
            return false;
        }

        return (strlen($property) == $lenght) ? false : true;
    }
    
    private static function alpha($property) {
        return (preg_match("/^([a-z])+$/i", $property) ) ? true : false;
    }
    
    private static function alpha_numeric($property) {
        return ( preg_match("/^([a-z0-9])+$/i", $property)) ? true : false;
    }
    
    private static function alpha_dash($property) {
        return ( preg_match("/^([-a-z0-9_-])+$/i", $property)) ? true : false;
    }
    
    private static function numeric($property) {
        return (bool)preg_match('/^[\-+]?[0-9]*\.?[0-9]+$/', $property);
    }
    
//    private static function is_numeric($property) {
//        return (is_numeric($property)) ? true : false;
//    }
    
    private static function integer($property) {
        return (bool)preg_match('/^[\-+]?[0-9]+$/', $property);
    }
    
    private static function greater_than($property, $size) {
        if (!is_numeric($property)) {
            return false;
        }
        
        if ($property > $size) {
            return true;
        }
        else {
            return false;
        }
    }

    private static function decimal($property) {
        return (bool)preg_match('/^[\-+]?[0-9]+\.[0-9]+$/', $property);
    }
    
    private static function valid_email($property) {
        return ( preg_match("/^([a-z0-9\+_\-]+)(\.[a-z0-9\+_\-]+)*@([a-z0-9\-]+\.)+[a-z]{2,6}$/ix", $property)) ? true : false;
    }
    
    private static function valid_emails($property) {
        if (strpos($property, ',') == false) {
            $trimmedEmail = trim($property);
            return self::valid_email($trimmedEmail);
        }
        else {
            $emailArray = explode(',', $property);
            
            foreach ($emailArray as $email) {
                $trimmedEmail = trim($email);
                $validEmail = self::valid_email($trimmedEmail);
                
                if (!empty($trimmedEmail) && $validEmail == false) {
                    return false;
                }
            }
            
            return true;
        }
    }
    
    /**
     * 
     * @param type $property The propety to be checked
     * @param String $type The type of the IP address - "ipv4" or "ipv6"
     * @return bool
     */
    private static function valid_ip($property, $type) {
        $ci =& get_instance();
        return $ci->input->valid_ip($property, $type);
    }
    
    private static function valid_base64($property) {
        return (bool)!preg_match('/[^a-zA-Z0-9\/\+=]/', $property);
    }
    
    /**
     * 
     * @param type $property the value of the property, which is passed by reference
     */
    private static function trim(&$property) {
        $trimmedValue = trim($property);
        $property = $trimmedValue;
        
        return true;
    }
    
    /**
     * 
     * @param type $property the property to be checked
     * @param type $field the database field in which the value will be checked
     * @return type
     */
    private static function unique($property, $field,$ID) {
        $ci =& get_instance();
        list($table, $field)=explode('.', $field);
      //  var_dump($ID);
        if(!is_null($ID)){
        $ci->db->where($table."ID != ".$ID);
        }
		$query = $ci->db->limit(1)->get_where($table, array($field => $property));
	//	var_dump($ci->db->last_query());
          //      var_dump($query->num_rows());
                $numOfRows = $query->num_rows();
		return $numOfRows === 0;
        
    }
    
    private static function xss_clean($property) {
        $ci =& get_instance();
        return $ci->security->xss_clean($property);
    }
}