<?php

class ValidationErrorMessages {
    
    public static function Translate($errorMessageArray, $language) {
        //Ако няма такъв превод или не е подаден езикк ще се използва английски по подразбиране
        if (empty($language) || !property_exists('ValidationErrorMessages', $language)) {
            $language = 'english';
        }
        //$returnArray съдържа превода на съобщенията за грешка
        $returnArray = array();
        
        $languageArray = self::$$language;
        
        foreach ($errorMessageArray as &$value) {
            $validationInfo = explode('[', $value);
            
            if (isset($validationInfo[1])) {
                //$validationRule съдържа грешката като min_lenght, а $argument съхранява ограничението, заради което е грешката
                //т.е. ако $validationRule, тогава $argument ще бъде 5
                $validationInfo[1] = substr_replace($validationInfo[1], "", -1);
                
                $validationRule =  $validationInfo[0];
                $argument = $validationInfo[1];
                
                $formattedString = sprintf($languageArray[$validationRule], $argument);  
            }
            else {
                //Ако няма втори аргумент, който ще се използва за min или max lenght 
                //тогава низовият литерал ще бъде само от една дума например "required"
                $validationRule =  $validationInfo[0];
                $formattedString = $languageArray[$validationRule];
            }
            
            array_push($returnArray, $formattedString);
        }
        
        return $returnArray;
    }
    
    public static $english = array(
        'required'      => "The field is required.",
        'min_length'    => "The field must be at least %d characters long.",
        'max_length'    => "The field must be no more than %d charactes.",
        'exact_length'  => "The must be exact %d characters long.",
        'alpha'         => "The field may only contain alphabetical characters.",
        'alpha_numeric' => "The field may only contain alpha-numeric characters.",
        'alpha_dash'    => "The field may only contain alpha-numeric characters, underscores, and dashes.",
        'numeric'       => "The field must contain only numbers.",
        'integer'       => "The field must contain an integer.",
        'greater_than'  => "The field must contain a number greater than %s.",
        'decimal'       => "The field must contain a decimal number.",
        'valid_email'   => "The field must contain a valid email address.",
        'valid_emails'  => "The field must contain all valid email addresses.",
        'valid_ip'      => "The field must contain a valid IP.",
        'valid_base64'  => "valid_base64",
        'unique'        => "The field must contain a unique value.",
        'xss_clean'     => "xss_clean",
        );
    
    public static $bulgarian = array(
        'required'      => "Полето е задължително.",
        'min_length'    => "Полето трябва да съдържа поне %d символа.",
        'max_length'    => "Полето не може да бъде повече от %d символа.",
        'exact_length'  => "Полето трябва да съдържа точно %d символа.",
        'alpha'         => "Полето може да съдържа само букви.",
        'alpha_numeric' => "Полето може да съдържа само букви и числа.",
        'alpha_dash'    => "Полето може да съдържа само букви, числа, долни черти и тирета.",
        'numeric'       => "Полето може да съдържа само числа.",
        'integer'       => "Полето трябва да съдържа цяло число.",
        'greater_than'  => "Поето трябва да съдържа число, по-голямо от %d.",
        'decimal'       => "Полето трябва да съдържа число с десетична точка.",
        'valid_email'   => "Полето трябва да съдържа валиден email адрес.",
        'valid_emails'  => "Полето трябва да съдържа само валидни email адреси.",
        'valid_ip'      => "Полето трябва да съдържа валидно IP.",
        'valid_base64'  => "valid_base64",
        'unique'        => "Полето трябва да съхранява уникална стойност.",
        'xss_clean'     => "xss_clean",
        );
}