<?php 
require_once('application/pito_class/PitoFormMain.php');

/**
* @property type $contentdataID
* @property type $shape
* @property type $position
* @property type $content
* @property type $backgroundColor
* @property type $size
* @property type $contentType
* @property type $language
* @property type $title
* @property type $createDate
* @property type $editDate
* @property type $deleted
* @property type $audioURL
*/
class ContentdataForm extends PitoFormMain {

    private $_parent;

    public $contentdataID;
    public $shape;
    public $position;
    public $content;
    public $backgroundColor;
    public $size;
    public $contentType;
    public $language;
    public $title;
    public $createDate;
    public $editDate;
    public $deleted;
    public $audioURL;


    public function __construct($nestingLevel=0, $elementID='') {
        $this->_parent = get_parent_class($this);

        //Gets the data for the form object and the relations 1:1. Returns an array of objects
        $fields = parent::GetFormAndRequirements('contentdata');
        $this->AssignFields($fields, $nestingLevel);
    }

    public function __get($name) {
        if (isset($this->$name)) {
            return $this->$name;
        } 
        else {
            if (isset(parent::$name)) {
                return parent::__get($name);
            }
            else {
                return null;
            }
        }
    }

    public function __set($name, $value) {
        if (property_exists($this, $name)) {
            $this->$name = $value;
        } 
        else { 
            if (property_exists($this->_parent, $name)) {
                parent::__set($name, $value);
            }
            else {
                throw new Exception('Unknown property ' . $name);
            }
        }
    }

    public function __isset($name) {
        return isset($this->$name);
    }

    /**
     * Returns an array with all the object's property names
     * @return Array
     */
    public function GetAllPropertyNames() {
        return array('contentdataID', 'shape', 'position', 'content', 'backgroundColor', 'size', 'contentType', 'language', 'title', 'createDate', 'editDate', 'deleted', 'audioURL', );
    }


}