<?php 
require_once('application/pito_class/PitoFormMain.php');

/**
* @property type $venueID
* @property type $venueName
* @property type $address
* @property type $logoURL
* @property type $createDate
* @property type $editDate
* @property type $deleted
* @property type $phone
* @property type $website
* @property type $url
* @property type $email
*/
class VenueForm extends PitoFormMain {

    private $_parent;

    public $venueID;
    public $venueName;
    public $address;
    public $logoURL;
    public $createDate;
    public $editDate;
    public $deleted;
    public $phone;
    public $website;
    public $url;
    public $email;


    public function __construct($nestingLevel=0, $elementID='') {
        $this->_parent = get_parent_class($this);

        //Gets the data for the form object and the relations 1:1. Returns an array of objects
        $fields = parent::GetFormAndRequirements('venue');
        $this->AssignFields($fields, $nestingLevel);
    }

    public function __get($name) {
        if (isset($this->$name)) {
            return $this->$name;
        } 
        else {
            if (isset(parent::$name)) {
                return parent::__get($name);
            }
            else {
                return null;
            }
        }
    }

    public function __set($name, $value) {
        if (property_exists($this, $name)) {
            $this->$name = $value;
        } 
        else { 
            if (property_exists($this->_parent, $name)) {
                parent::__set($name, $value);
            }
            else {
                throw new Exception('Unknown property ' . $name);
            }
        }
    }

    public function __isset($name) {
        return isset($this->$name);
    }

    /**
     * Returns an array with all the object's property names
     * @return Array
     */
    public function GetAllPropertyNames() {
        return array('venueID', 'venueName', 'address', 'logoURL', 'createDate', 'editDate', 'deleted', 'phone', 'website', 'url', 'email', );
    }


}