<?php 
require_once('application/pito_class/PitoMain.php');
require_once('application/pito_class/PitoValidation.php');

/**
* @property type $participantTypeID
* @property type $createDate
* @property type $editDate
* @property type $deleted
*/
class PatricipanttypeObject extends PitoMain {

    private $_parent;
    protected $_type;

    protected $participantTypeID;
    protected $createDate;
    protected $editDate;
    protected $deleted;

    protected $patricipanttypeForm;
    protected $errorArray;


    public function __construct($nestingLevel=0, $elementID='') {
        $this->_parent = get_parent_class($this);

        //Gets only the fields with the relations 1:1. Returns an array of objects
        $fields = parent::GetFormAndRequirements('patricipanttype');
        $this->AssignFields($fields, $nestingLevel);
        $this->patricipanttypeForm = new PatricipanttypeForm();
        $this->errorArray = array();

        $this->_type = str_replace('Object', '', get_class());

        if (!empty($elementID)) {
            $this->LoadElement($elementID, $nestingLevel);
        }
    }

    public function __get($name) {
        if (isset($this->$name)) {
            return $this->$name;
        } 
        else {
            if (isset(parent::$name)) {
                return parent::__get($name);
            }
            else {
                return null;
            }
        }
    }

    public function __set($name, $value) {
        if (property_exists($this, $name)) {
            $requirements = $this->patricipanttypeForm->$name;
            $this->errorArray[$name] = PitoValidation::Validate($value, $requirements['requirements']);

            if (empty($this->errorArray[$name]) || $this->errorArray[$name] === true) {
                if (!empty($this->errorArray) && key_exists($name, $this->errorArray)) {
                    unset($this->errorArray[$name]);
                }

                $this->$name = $value;
            }
        } 
        else { 
            if (property_exists($this->_parent, $name)) {
                parent::__set($name, $value);
            }
            else {
                throw new Exception('Unknown property ' . $name);
            }
        }
    }

    public function __isset($name) {
        return isset($this->$name);
    }

    /**
     * Loads the values in the object
     * @param type  $ID              the ID of the object to load
     * @param integer $nestingLevel  the number of nested objects
     * @throws Exception if an element with the passed ID is not found
     */
    public function LoadElement($ID, $nestingLevel=0) {
        $object = parent::GetObjectById('patricipanttype', $ID);
        $fields = parent::GetFormAndRequirements('patricipanttype');

        //Взима имената на всичките property-та
        $classProperties = get_object_vars($this);
        if (empty($object)) {
            $className = get_class($this);
            return;
        }

        foreach ($object as $key => $value) {
            if (property_exists($this, $key)) {
                $this->$key = $value;
            }
            else {
                $propName = substr($key, 0, -2);
                if (property_exists($this, $propName)){ if($nestingLevel > 0) {
                $passedNestingLevel = $nestingLevel;
                $passedNestingLevel--;

                $className = parent::GetPropertyClass($propName, 'patricipanttype');

                $this->$propName = new $className();
                    $this->$propName->LoadElement($value, $passedNestingLevel);
                }else{$this->$propName = $value;}}            }
        }

        //Ако някоя член-данна има суфикс List тогава се търси за релация в базата.
        //Link показва, че съществува релация с друга таблица докато името на променливата
        //указва с коя таблица има връзка. 
        foreach ($classProperties as $key => $value) {
            //Името на променливата без последните четири символа (без List)
            $listPropName = substr($key, 0, -4);
            //Последните четири символа (List)
            $propEndName = substr($key, strlen($listPropName));
            //Проверява се дали името на променливата завършва на "List" - ако е се търси релация
            if ($propEndName == 'List') {
                if (property_exists($this, $key) && $nestingLevel > 0) {
                $passedNestingLevel = $nestingLevel;
                $passedNestingLevel--;
                    $this->$key = parent::FindRelatedRecords($listPropName, 'patricipanttype', $this->patricipanttypeID, $passedNestingLevel);
                }
            }
        }
    }

    /**
     * Saves or updates the object's values to the database
     */
    public function Save() {
        $arrayToInsert = $this->GetArrayForDatabase();
        $objectID = $this->GetID();

        $ci =& get_instance();
        $ci->load->model('PitoModel');
        $patricipanttypeID = $ci->PitoModel->SaveObject($arrayToInsert, 'patricipanttype', $objectID);

        if($patricipanttypeID !== true){
            $this->patricipanttypeID = $patricipanttypeID;
        }
    }

    /**
     * Save the object's values to the database
     * * @deprecated since version 2.0
     */
    public function Create() {
        $ci =& get_instance();
        $ci->load->model('PatricipanttypeModel');
        $this->patricipanttypeID = $ci->PatricipanttypeModel->Save($this);
    }

    /**
     * Saves the changes to the database
     * * @deprecated since version 2.0
     */
    public function Update() {
        $ci =& get_instance();
        $ci->load->model('PatricipanttypeModel');
        $ci->PatricipanttypeModel->Save($this);
    }

    /**
     * Sets the object as deleted
     */
    public function Delete() {
        $ci =& get_instance();
        $ci->load->model('PatricipanttypeModel');
        $ci->PatricipanttypeModel->Delete($this);
    }

    /**
     * Searches in the database on for an array where the key is the colum and the value is the search criteria
     * @param type  $searchArray  the array that holds the search criteria as key => value
     * @param integer $nestingLevel the nested objects count
     * @return array
     */
    public static function Search($searchArray, $nestingLevel=0,$sortArray=array(),$page = "",$limit="") {
        $resultArray = parent::Search('patricipanttype', $searchArray, $nestingLevel--,$sortArray,$page = "",$limit="");
        return $resultArray;
    }

    /**
     * Gets all of the elements in the database
     * @param integer $nestingLevel the nested objects count
     * @return array
     */
    public function GetAll($nestingLevel=0) {
        $searchArray = array(
            array(
                'column' => 'patricipanttypeID',
                'value' => 0,
                'operator' => '>=',
            )
        );

        $passedNestingLevel = $nestingLevel;
        $passedNestingLevel--;
        $resultArray = parent::Search('patricipanttype', $searchArray, $passedNestingLevel);
        return $resultArray;
    }

    /**
     * Returns an array with all the object's property names
     * @return Array
     */
    public function GetAllPropertyNames() {
        return array('participantTypeID', 'createDate', 'editDate', 'deleted', );
    }

    private function GetArrayForDatabase() {
    //Ако данните в обекта не са валидни ще се хвърли Exception вместо да се подаде неверен масив
    $this->Validate();
    $errorArray = $this->GetErrorArray();

    if (!empty($errorArray)) {
        throw new Exception("Cannot save object: invalid value for one or more properties.");
    }

    $mappedFields = array(
        'patricipanttypeID' => 'participantTypeID',
        'patricipanttype' => 'createDate',
        'createDate' => 'editDate',
        'editDate' => 'deleted',
        'deleted' => '',
    );

    $objectValues = get_object_vars($this);

    foreach ($objectValues as $key => &$value) {
        //Ако член данна няма да се записва в базата се маха
        if (!in_array($key, $mappedFields)) {
            unset($objectValues[$key]);
        }
        //Проверява се дали property-то не е обект, ако е се взима само ID-то му
        if (is_object($value)) {
            if (method_exists($value, 'GetID')) {
                $value = $value->GetID();
            }
            else {
                //Частен случай, ако е обект, но няма GetID() метод
                $value = null;
            }
        }
    }

        $arrayToReturn = array();

        foreach ($mappedFields as $key => $value) {
            $arrayToReturn[$key] = $objectValues[$value];
        }

        return $arrayToReturn;
    }

    /**
     * Returns the object's properties as a JSON object
     * @param integer $nestingLevel the nesting level of the object's properties that are object themselves
     * * @param array $objectNameArray the array that holds the previously called objects
     * @return array
     */
    public function GetJsonData($nestingLevel=0, $objectNameArray = array()){
        $className = get_class($this);

        //Ако името на класа на обекта е в масива, тогава информацията вече е извлечена на по-ранен
        //етап, а в този case се е получило рекурсивно извикване на GetJsonData за този обект
        if (in_array($className, $objectNameArray)) {
            return null;
        }
        $objectNameArray[$className] = $className;

        $objectValues = get_object_vars($this);
        $propertyNames = $this->GetAllPropertyNames();

        foreach ($objectValues as $key => &$value) {
            //Ако член данна не трябва да се предоставя на потребителя се маха от масива със стойностите на обекта
            if (!in_array($key, $propertyNames) && $key != '_type') {
                unset($objectValues[$key]);
            }

            if (is_object($value) && method_exists($value, 'GetJsonData') && $nestingLevel > 0) {
                $value = $value->GetJsonData($nestingLevel - 1, $objectNameArray);
            }
            else {
                if (is_object($value) && $nestingLevel <= 0) {
                    if (method_exists($value, 'GetID')) {
                        $value = $value->GetID();
                    }
                    else {
                        $value = null;
                    }
                }
            }
        }

        return $objectValues;
    }

    /**
     * Returns the error array from the validation. Each key is a name of a property in which there were validation errors
     * and holds an array in which each element is an error
     * @return array
     */
    public function GetErrorArray() {
        return $this->errorArray;
    }

    /**
     * Runs through the object and checks if the values pass the validation rules
     * @return boolean
     */
    public function Validate() {
        $properties = $this->GetAllPropertyNames();

        foreach ($properties as $property) {
            $requirements = $this->patricipanttypeForm->$property;
            $this->errorArray[$property] = PitoValidation::Validate($this->$property, $requirements['requirements']);

            if (empty($this->errorArray[$property]) || $this->errorArray[$property] === true) {
                unset($this->errorArray[$property]);
            }
        }

        if (empty($this->errorArray)) {
            return true;
        }
        else {
            return false;
        }
    }

    /**
     * Gets the object' ID or returns null
     * @return int
     */
    public function GetID() {
        if (!empty($this->participantTypeID)) {
            return $this->participantTypeID;
        }
        else {
            return null;
        }
    }

    /**
     * Sets the properties of the object by the values from a passed object or array
     * It will only set a propery if the passed object/array has a property/value with the same name
    * @param mixed $object
     */
    public function AssignValuesFromObject($object) {
        $propertyNames = $this->GetAllPropertyNames();

        if (is_object($object)) {
            foreach ($propertyNames as $property) {
                if (property_exists($this, $property) && property_exists($object, $property)) {
                    //Проверка дали $object->property-то не е вложен обект от някакъв тип
                    if (is_object($object->$property) && property_exists($object->$property, '_type')) {
                        $className = $object->$property->_type . "Custom";
                        //Ако няма Custom клас, да се използва автоматично генерираният
                        //if (!class_exists($className)) {
                            $className = $object->$property->_type . "Object";
                        //}

                        //Ако това property е обект, но не е инстанциран се създава
                        if (!is_object($this->$property) && class_exists($className)) {
                            $this->$property = new $className();
                            $this->$property->AssignValuesFromObject($object->$property);
                        }
                    }
                    else {
                        $this->$property = $object->$property;
                    }
                }
            }
        }

        if (is_array($object)) {
            foreach ($propertyNames as $property) {
                if (property_exists($this, $property) && key_exists($property, $object)) {
                    $this->$property = $object[$property];
                }
            }
        }
    }
}